
#**********************************************************************
#* Code corresponding to the article:                                 *
#* A Computational Approach to Overtaking Station Track Layout Design *
#* Using Graphs: An Extension That Supports Special Turnouts —An      *
#* Improved Alternative Track Layout Proposal                         *
#* by Eugenio Roanes-Lozano                                           *
#* (published at MDPI-Algorithms journal                              *
#**********************************************************************

  First:=proc(L)
    op(1,L);
   end proc:

  Last:=proc(L)  
    op(nops(L),L);
   end proc:
 
  ButFirst:=proc(L)  
    L[2..nops(L)];
   end proc:
  
  ButLast:=proc(L)
    L[1..nops(L)-1];
   end proc:

  AreReachableList:=proc(graph,initial,list)
   local i;
    for i in list do print(i,IsReachable(graph,initial,i)) end do;
   end proc:
  
  IsReachableThrough:=proc(graph,initial,final,through)
     IsReachable(graph,initial,through) and IsReachable(graph,through,final);
   end:
  
  ShortestPathThrough:=proc(graph,initial,final,through)
     local L,L1,L2;
     if IsReachableThrough(graph,initial,final,through)
        then L1 := ShortestPath(graph,initial,through); 
             L2 := ShortestPath(graph,through,final);
             L  := [op(L1),op(ButFirst(L2))]
        else L  := []
      end if;
   end:
  
  IndispensableVerticesInTrail:=proc(graph,trail) 
   local i,L,Gaux; 
    L:=[];
    for i in ButFirst(ButLast(trail)) do     
        Gaux:=DeleteVertex(graph,i,inplace=false);
        if IsReachable(Gaux,First(trail),Last(trail))=false       
           then L:=[op(L),i]      
         end if; 
      end do; 
    end proc:
  
  IndispensableVerticesList:=proc(graph,initial,final,list) 
   local i,L,Gaux; 
    L:=[];
    for i in list do 
        if i<>initial and i<>final then    #just in case they are erroneously included
           Gaux:=DeleteVertex(graph,i,inplace=false);  
           if IsReachable(Gaux,initial,final)=false       
              then L:=[op(L),i];  
            end if;
         end if; 
      end do; 
    L;
   end proc:

  DeleteVertices:=proc(graph,list) 
   local i,Gaux;
    Gaux:=graph;
    for i in list do
        Gaux:=DeleteVertex(Gaux,i,inplace=false):
     end do;
    end proc:

  NumberTrailsExceptThrough:=proc(graph,initial,final,erase,list,detailIt) 
   local i,Laux,Gaux,num;
    num:=0;
    if nops(erase)>0 
       then Gaux:=DeleteVertices(G,erase,inplace=false) 
       else Gaux:=G
     end if; 
    Laux := [op({op(list)} minus {op(erase)})]; 
    for i in Laux do 
          if detailIt=1 then print(i,IsReachableThrough(Gaux,initial,final,i)) end if; 
          if IsReachableThrough(Gaux,initial,final,i) then num:=num+1 end if;
     end do;
    num;
   end proc:

  TotalNumberTrailsExceptThrough:=proc(graph,initial1,final1,initial2,final2,list) 
   local i,num;
    num:=0;
    for i in list do        
        num:=num +
        NumberTrailsExceptThrough(graph,initial2,final2,
#                                 ShortestPathThrough(G,initial1,final1,i),list,0);   #OLD - IN ESTACIONES
                                  [op({i,op(ShortestPathThrough(G,initial1,final1,i))})],list,0); #NEW 
      end do;
    end proc:

  
